---
header-includes:
 - \usepackage[T1]{fontenc}
 - \usepackage[french]{babel}
 - \usepackage{datetime}
 - \usepackage{hyperref}
---

# Semaine 3: Les systèmes experts à base de schémas

Questions: 

- Faire de l'inférence sur les propriétés d'une instance d'un objet à l'intérieur de celui-ci?

Remarques:

- Je vous beaucoup d'articles qui traitent de sujets dans l'enseignement de la médecine


## Article: Modelling Hybrid Rule/Frame-Based Expert Systems Using Coloured Petri Nets

Année: 1995
Source: [](https://pdfs.semanticscholar.org/214a/8830b8714de184e4abc18b0dfa8565d40340.pdf)

> The use of this hybrid approach integrates the power of organizing data objects in a class hierarchy and reasoning about the objects through user pre-defined logical associations. This advantage accounts for many popular expert system developing software, such as ADS, ART, EXSYS EL, KAPPA-PC, KBMS, Nexpert Object, Level5 Object, ProKappa, ReMind, which combine some sort of frame-based representation with a rule-based inference engine.


## Artificial Intelligence: A modern Approach Section 10.6 - Russell and Norvig

Source: Livre papier original que je possède.

## A Framework for Representing Knowledge - Marvin Minsky

Source: [A Framework for Representing Knowledge - MIT-AI Laboratory Memo 306, June, 1974.](http://web.media.mit.edu/%7Eminsky/papers/Frames/frames.html)

- Les morceaux (`chunks`) de raisonnement, langage, mémoire et perception que nous utilisont sont plus larges et plus structurés que les théories actuelles de psychologie et d'intelligence artificielle, qui considèrent la connaissance comme des fragments simples et séparés. Selon Minsky, les approches actuelles ne considèrent pas la force et la rapidité des activités mentales.

- Dans une nouvelle situation, on trouve un schéma correspondant dans notre mémoire et on l'adapte. 

- **Commentaire personnel:** Dans le cas des systèmes à base de règles, on effaçait complètement la mémoire de travail lorsqu'on recommençait un nouveau problème.

- Un schéma est une structure pour représenter une situation stéréotypée:
    - Comment utiliser le schéma
    - Qu'est ce qu'on s'attend qui se produise par la suite
    - Que faire si ça n'arrive pas

- Noeuds et relations
    - Niveaux plus élevés: choses toujours vraies à propos de la situation
    - Terminaux (`slots`):  instances spécifiques
    - Conditions: types et relations, sous-schémas

- Systèmes de schémas:
    - Plusieurs schémas. 
    - Transformations entre les schémas
    - Notion d'imagerie, de visualisation mentale
    - Partagent les mêmes terminaux
    - Valeurs par défaut faciles à remplacer.

- Réseau d'extraction d'informations
    - Relient les systèmes de schémas entre eux
    - **Commentaire personnel:** Un peu comme le web sémantique le fait beaucoup plus tard.

- Processus d'appariement: 
    - Information interne et connaîssance des objectifs du système
    - Une fois le bon schéma identifié: complétion des terminaux
    - Actions suivant une transformation

1. Vision
    - La théorie de Gestalt est trop simpliste
    - Traitement en parallèle: surtout au niveau du traitement sensoriel, mais pas dans la construction de concepts complexes.
    - Connaissance procédurale
    - Comment suivre le mouvement sans tout recalculer à chaque image?
    - Un schéma = un point de vue. Ex: Les terminaux sont les faces d'un cube dont on ne voit jamais plus de 3 faces à la fois. Les relations entre les schémas sont les actions de rotation ou de déplacement. ![](images/semaine04/minsky-frames/Image4.gif){width=50%}
    - Continuité de la vision: persistence de l'assignement aux terminaux de différents schémas de vision.
    - **Commentaire personnel:** Explique les illusions d'optique ?
    - Valeurs par défaut: exemple du ballon (taille, couleur, poids)

## Society of Mind - Marvin Minsky - Chapter 24

Source: Livre papier original que je possède.



## Lecture de notes de cours

### Lecture 1

Référence: [Milos Hauskrecht - CS 2740 Knowledge Representation - Lecture 11](https://people.cs.pitt.edu/~milos/courses/cs2740/Lectures/class11.pdf)

### Lecture 2

Référence: [John A. Bullinaria, 2003 - AITA : Frame Based Systems](http://www.cs.bham.ac.uk/~jxb/AITA/w6s3.pdf)

## Exemple: Monitoring de moteurs diesel



## Outils 

### KL-ONE



### CLIPS



### Protégé

Référence: [Site web du logiciel Stanford Protégé](http://protege.stanford.edu/)
Article: [Frame-based systems: Protege (Bioinformatics)](http://what-when-how.com/bioinformatics/frame-based-systems-protege-bioinformatics/)

### Exemple de réseau sémantique et raisonnement avec Protégé et les données 